include 'Vram.inc'
include 'ZeroPage.inc'

ext InitVram_, InitSound_, SoundHandler

dseg
SaveInt:
    defw 0
TimerCount: 
    defb 0
Division:
    defb 0

cseg
ScreenMode:
    defb $3F,$28,$31,$24,$26,$00
    defb $20,$22,$01,$07,$67,$08
    defb (high VramOrg) shr 3
    defb (low VramOrg) shr 3

PaletteValues:
defb $7
defb $17
defb $26
defb $36
defb $47
defb $57
defb $66
defb $76
defb $81
defb $91
defb $A0
defb $B0
defb $C1
defb $D1
defb $E0
defb $F0


; void Init();
cseg
Init_: public Init_
    pha
        ldx #$c4 | lda #154 | jsr $fff4

        ldx #0
        do
            stx $fe00
            lda ScreenMode,x
            sta $fe01
            inx
            cpx #14
        while ne | wend

        ldx #0
        do
            lda PaletteValues,x
            sta $fe21
            inx
            cpx #16
        while ne | wend

        jsr InitVram_
        jsr InitSound_

        sei
            lda #0 | sta TimerCount | sta Division
            lda $0204 | sta SaveInt
            lda $0205 | sta SaveInt+1
            lda #low Handler | sta $0204
            lda #high Handler | sta $0205
            ; lda #not 2 | sta $fe4e
            ; lda #$80 or 2 | sta $fe4e
        cli
    pla
rts


Handler: public Handler
    pha
        lda $fe4d
        and #$40
        if ne
            lda Division
            sec | sbc #6
            if cc
                adc #10
                pha
                txa | pha
                tya | pha
                    inc TimerCount
                    jsr SoundHandler
                pla | tay
                pla | tax
                pla
            endif
            sta Division
        endif
    pla
jmp (SaveInt)


; void WaitTimer(byte t);
dseg
WaitTimer_@Param0: public WaitTimer_@Param0
    defb 0
cseg
WaitTimer_: public WaitTimer_
    pha
        do
            lda TimerCount
            cmp WaitTimer_@Param0
        while cc | wend
        sei
            lda #0 | sta TimerCount
        cli
    pla
rts
